; 

    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\macros\macros.asm

    include hash.inc
    include ..\timers.asm

    include \masm32\include\debug.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib

    includelib hash.lib

    includelib \masm32\lib\debug.lib

; 

m2m     MACRO M1, M2
            push M2
            pop  M1
        ENDM

; 

 .data
 align 16

    hInstance       dd 0
    hwnd            dd 0                ; owner window
    hf              dd 0                ; file handle
    MyHeap          dd 0
    tmp             dd 0
    Mem1            dd 0
    error           dd 0

    hash_data   HASH1_STRUCT <?,?,?,?>     ; HASH work area

    fileName        db 'rand.smp',0
    

; 

 .code
align 4

; 
;
;  Hash function
;
;  IN:  esi - HASH structure
;       eax - value to store
;
; -------------------------------------------------------------------------
Hash_func:
            ret

; 

Start:


count   equ 4096
; 

            invoke GetModuleHandle, NULL
            mov     hInstance,eax

            call GetProcessHeap
            mov     MyHeap,eax

            ;invoke HeapAlloc,MyHeap,HEAP_ZERO_MEMORY,count*4
            ;cmp     eax,NULL
            ;jz  @_END
            ;mov     edi,eax
            ;mov     Mem1,eax

; -------------------------------------------------------------------------

            invoke HASH1_init,ADDR hash_data,count,NULL,NULL        ;ADDR Hash_func
            cmp     eax,NULL
            jz  @_END
        mov     dword ptr collision,0
            timer_begin 1,NORMAL_PRIORITY_CLASS
            mov     eax,count*count
@_Store:
            push    eax

comment ^
    xor edx, edx
    mov ecx, 127773
    div ecx
    mov ecx, eax
    mov eax, 16807
    mul edx
    mov edx, ecx
    mov ecx, eax
    mov eax, 2836
    mul edx
    sub ecx, eax
    xor edx, edx
    mov eax, ecx
^
;PrintHex eax

            push    ebx
            push    ecx
            invoke HASH1_store,ADDR hash_data
            pop     ecx
            pop     ebx
            pop     eax
            jz  @_Store1
            sub     eax,1
            jnz @_Store
@_Store1:
            timer_end
PrintHex eax,'elapsed'
mov eax,collision
PrintHex eax,'collisions'
ASSUME  edx:PTR HASH1_STRUCT
mov     edx,offset hash_data
mov eax,[edx].MAXPROBE
PrintHex eax,'maxprobe'
PrintText '----'
            ASSUME  edx:NOTHING

; -------------------------------------------------------------------------
            mov     dword ptr collision,0
            ASSUME  edx:PTR HASH1_STRUCT
            timer_begin 1,NORMAL_PRIORITY_CLASS
            mov     eax,count*count
@_Search:
            push    eax

comment ^
    xor edx, edx
    mov ecx, 127773
    div ecx
    mov ecx, eax
    mov eax, 16807
    mul edx
    mov edx, ecx
    mov ecx, eax
    mov eax, 2836
    mul edx
    sub ecx, eax
    xor edx, edx
    mov eax, ecx
^
;PrintHex eax
            push    ebx
            push    ecx
            invoke HASH1_search,ADDR hash_data
            pop     ecx
            pop     ebx
            or      esi,esi
            jz  @_Search1
            cmp eax,[esi]
            jz  @_Search1
            add dword ptr error,1
@_Search1:
            pop     eax
            sub     eax,1
            jnz @_Search

            ASSUME  edx:NOTHING
            timer_end
PrintHex eax,'elapsed'
mov eax,collision
PrintHex eax,'collisions'
mov eax,error
PrintHex eax,'errors'

            invoke HASH1_destroy,ADDR hash_data

; -------------------------------------------------------------------------
@_END:
            invoke HeapDestroy,MyHeap

            invoke ExitProcess,eax
; 

end Start
